searchNodes=[{"doc":"A HTTP signed implementation of Elasticsearch.API to interact with AWS Elasticsearch Service.","ref":"Elasticsearch.API.AWS.html","title":"Elasticsearch.API.AWS","type":"module"},{"doc":"","ref":"Elasticsearch.API.AWS.html#aws_credentials/1","title":"Elasticsearch.API.AWS.aws_credentials/1","type":"function"},{"doc":"","ref":"Elasticsearch.API.AWS.html#build_signed_request/3","title":"Elasticsearch.API.AWS.build_signed_request/3","type":"function"},{"doc":"","ref":"Elasticsearch.API.AWS.html#cleanup_default_options/1","title":"Elasticsearch.API.AWS.cleanup_default_options/1","type":"function"},{"doc":"","ref":"Elasticsearch.Test.Store.html","title":"Elasticsearch.Test.Store","type":"module"},{"doc":"Builds Elasticsearch indexes using a zero-downtime, hot-swap technique.Build an index for the given alias, with a timestamp: alias-12323123Bulk upload data to that index using store and sources.Alias the alias to alias-12323123.Remove old indexes beginning with alias.Refresh alias-12323123.For a functional version of this approach, see Elasticsearch.Index.hot_swap/4.Options--cluster: The Elasticsearch.Cluster to build the indexes to.--bulk-page-size: (Optional) The number of documents to post to the cluster in each bulk page upload. Default: 5000--bulk-wait-interval: (Optional) The number of milliseconds to wait between posting each bulk page, to avoid overloading your cluster. Default: 0Example$ mix elasticsearch.build posts [index2] [index3] --cluster MyApp.ClusterTo build an index only if it does not exist, use the --existing option:$ mix elasticsearch.build posts --existing --cluster MyApp.Cluster Index posts already exists.You can also specify --bulk-page-size and --bulk-wait-interval manually:$ mix elasticsearch.build posts --cluster MyApp.Cluster --bulk-page-size 1000 --bulk-wait-interval 500","ref":"Mix.Tasks.Elasticsearch.Build.html","title":"Mix.Tasks.Elasticsearch.Build","type":"task"},{"doc":"FOR DEVELOPMENT USE ONLY.This task is provided as a convenient way to install a particular version of Elasticsearch for your project on a development machine. Use Elasticsearch.Executable to add the executables to your app's supervision tree in the Mix :dev environment.Example# Installs Elasticsearch and Kibana 5.1.1 to vendor/ mix elasticsearch.install vendor --version 5.1.1","ref":"Mix.Tasks.Elasticsearch.Install.html","title":"Mix.Tasks.Elasticsearch.Install","type":"task"},{"doc":"Entry-point for interacting with your Elasticsearch cluster(s).You should configure at least one Elasticsearch.Cluster in order to use the functions in this module, or else you'll need to pass all the configuration for the cluster into each function call.TelemetryThe following events are published:[:elasticsearch, :request, :start] - emitted at the beginning of the request to Elasticsearch.Measurement: %{system_time: System.system_time()}Metadata: %{telemetry_span_context: term(), config: Elasticsearch.Cluster.config(), method: Elasticsearch.API.method(), url: Elasticsearch.API.url(), data: Elasticsearch.API.data()}[:elasticsearch, :request, :stop] - emitted at the end of the request to Elasticsearch.Measurement: %{duration: native_time}Metadata: %{telemetry_span_context: term(), result: Elasticsearch.API.response()}[:elasticsearch, :request, :exception] - emitted when an exception has been raised.Measurement: %{system_time: System.system_time()}Metadata: %{telemetry_span_context: term(), kind: Exception.kind(), reason: term(), stacktrace: Exception.stacktrace()}","ref":"Elasticsearch.html","title":"Elasticsearch","type":"module"},{"doc":"Deletes data at a given Elasticsearch URL.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Elasticsearch.delete(Cluster, &quot;/posts&quot;) {:ok, %{&quot;acknowledged&quot; =&gt; true}}It returns an error if the given resource does not exist.iex&gt; Elasticsearch.delete(Cluster, &quot;/nonexistent&quot;) {:error, %Elasticsearch.Exception{col: nil, line: nil, message: &quot;no such index&quot;, query: nil, raw: %{&quot;error&quot; =&gt; %{&quot;index&quot; =&gt; &quot;nonexistent&quot;, &quot;index_uuid&quot; =&gt; &quot;_na_&quot;, &quot;reason&quot; =&gt; &quot;no such index&quot;, &quot;resource.id&quot; =&gt; &quot;nonexistent&quot;, &quot;resource.type&quot; =&gt; &quot;index_or_alias&quot;, &quot;root_cause&quot; =&gt; [%{&quot;index&quot; =&gt; &quot;nonexistent&quot;, &quot;index_uuid&quot; =&gt; &quot;_na_&quot;, &quot;reason&quot; =&gt; &quot;no such index&quot;, &quot;resource.id&quot; =&gt; &quot;nonexistent&quot;, &quot;resource.type&quot; =&gt; &quot;index_or_alias&quot;, &quot;type&quot; =&gt; &quot;index_not_found_exception&quot;}], &quot;type&quot; =&gt; &quot;index_not_found_exception&quot;}, &quot;status&quot; =&gt; 404}, status: 404, type: &quot;index_not_found_exception&quot;}}","ref":"Elasticsearch.html#delete/3","title":"Elasticsearch.delete/3","type":"function"},{"doc":"Same as delete/1, but returns the response and raises errors.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Elasticsearch.delete!(Cluster, &quot;/posts&quot;) %{&quot;acknowledged&quot; =&gt; true}Raises an error if the resource is invalid.iex&gt; Elasticsearch.delete!(Cluster, &quot;/nonexistent&quot;) ** (Elasticsearch.Exception) (index_not_found_exception) no such index","ref":"Elasticsearch.html#delete!/3","title":"Elasticsearch.delete!/3","type":"function"},{"doc":"Deletes a document from a given index.The document must implement the Elasticsearch.Document protocol.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; struct = %Post{id: 123, title: &quot;Post&quot;, author: &quot;Author&quot;} ...&gt; Elasticsearch.put_document!(Cluster, struct, &quot;posts-1&quot;) ...&gt; Elasticsearch.delete_document(Cluster, struct, &quot;posts-1&quot;) {:ok, %{ &quot;_id&quot; =&gt; &quot;123&quot;, &quot;_index&quot; =&gt; &quot;posts-1&quot;, &quot;_primary_term&quot; =&gt; 1, &quot;_seq_no&quot; =&gt; 1, &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, &quot;_type&quot; =&gt; &quot;_doc&quot;, &quot;_version&quot; =&gt; 2, &quot;result&quot; =&gt; &quot;deleted&quot; }}","ref":"Elasticsearch.html#delete_document/3","title":"Elasticsearch.delete_document/3","type":"function"},{"doc":"Same as delete_document/2, but raises on errors.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; struct = %Post{id: 123, title: &quot;Post&quot;, author: &quot;Author&quot;} ...&gt; Elasticsearch.put_document!(Cluster, struct, &quot;posts-1&quot;) ...&gt; Elasticsearch.delete_document!(Cluster, struct, &quot;posts-1&quot;) %{ &quot;_id&quot; =&gt; &quot;123&quot;, &quot;_index&quot; =&gt; &quot;posts-1&quot;, &quot;_primary_term&quot; =&gt; 1, &quot;_seq_no&quot; =&gt; 1, &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, &quot;_type&quot; =&gt; &quot;_doc&quot;, &quot;_version&quot; =&gt; 2, &quot;result&quot; =&gt; &quot;deleted&quot; }","ref":"Elasticsearch.html#delete_document!/3","title":"Elasticsearch.delete_document!/3","type":"function"},{"doc":"Gets the contents of a path from the Elasticsearch API.Examplesiex&gt; {:ok, resp} = Elasticsearch.get(Cluster, &quot;/_cat/health?format=json&quot;) ...&gt; is_list(resp) true iex&gt; Elasticsearch.get(Cluster, &quot;/nonexistent&quot;) {:error, %Elasticsearch.Exception{col: nil, line: nil, message: &quot;no such index&quot;, query: nil, raw: %{&quot;error&quot; =&gt; %{&quot;index&quot; =&gt; &quot;nonexistent&quot;, &quot;index_uuid&quot; =&gt; &quot;_na_&quot;, &quot;reason&quot; =&gt; &quot;no such index&quot;, &quot;resource.id&quot; =&gt; &quot;nonexistent&quot;, &quot;resource.type&quot; =&gt; &quot;index_or_alias&quot;, &quot;root_cause&quot; =&gt; [%{&quot;index&quot; =&gt; &quot;nonexistent&quot;, &quot;index_uuid&quot; =&gt; &quot;_na_&quot;, &quot;reason&quot; =&gt; &quot;no such index&quot;, &quot;resource.id&quot; =&gt; &quot;nonexistent&quot;, &quot;resource.type&quot; =&gt; &quot;index_or_alias&quot;, &quot;type&quot; =&gt; &quot;index_not_found_exception&quot;}], &quot;type&quot; =&gt; &quot;index_not_found_exception&quot;}, &quot;status&quot; =&gt; 404}, status: 404, type: &quot;index_not_found_exception&quot;}}","ref":"Elasticsearch.html#get/3","title":"Elasticsearch.get/3","type":"function"},{"doc":"The same as get/1, but returns the response instead of a tuple. Raises on errors.Examplesiex&gt; resp = Elasticsearch.get!(Cluster, &quot;/_cat/health?format=json&quot;) ...&gt; is_list(resp) true iex&gt; Elasticsearch.get!(Cluster, &quot;/nonexistent&quot;) ** (Elasticsearch.Exception) (index_not_found_exception) no such index","ref":"Elasticsearch.html#get!/3","title":"Elasticsearch.get!/3","type":"function"},{"doc":"Determines whether a resource exists at a given Elasticsearch pathExamplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Elasticsearch.head(Cluster, &quot;/posts&quot;) {:ok, &quot;&quot;}It returns an error if the given resource does not exist.iex&gt; Elasticsearch.head(Cluster, &quot;/nonexistent&quot;) {:error, %Elasticsearch.Exception{ col: nil, line: nil, message: &quot;&quot;, query: nil, raw: nil, status: nil, type: nil }}","ref":"Elasticsearch.html#head/3","title":"Elasticsearch.head/3","type":"function"},{"doc":"Same as head/1, but returns the response and raises errors.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Elasticsearch.head!(Cluster, &quot;/posts&quot;) &quot;&quot;Raises an error if the resource is invalid.iex&gt; Elasticsearch.head!(Cluster, &quot;/nonexistent&quot;) ** (Elasticsearch.Exception)","ref":"Elasticsearch.html#head!/3","title":"Elasticsearch.head!/3","type":"function"},{"doc":"Posts data or queries to a given Elasticsearch path.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; query = %{&quot;query&quot; =&gt; %{&quot;match_all&quot; =&gt; %{}}} ...&gt; {:ok, resp} = Elasticsearch.post(Cluster, &quot;/posts/_search&quot;, query) ...&gt; resp[&quot;hits&quot;][&quot;hits&quot;] []","ref":"Elasticsearch.html#post/4","title":"Elasticsearch.post/4","type":"function"},{"doc":"The same as post/1, but returns the response. Raises on errors.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; query = %{&quot;query&quot; =&gt; %{&quot;match_all&quot; =&gt; %{}}} ...&gt; resp = Elasticsearch.post!(Cluster, &quot;/posts/_search&quot;, query) ...&gt; is_map(resp) trueRaises an error if the path is invalid or another error occurs:iex&gt; query = %{&quot;query&quot; =&gt; %{&quot;match_all&quot; =&gt; %{}}} ...&gt; Elasticsearch.post!(Cluster, &quot;/nonexistent/_search&quot;, query) ** (Elasticsearch.Exception) (index_not_found_exception) no such index","ref":"Elasticsearch.html#post!/4","title":"Elasticsearch.post!/4","type":"function"},{"doc":"Creates a document in a given index. Use this function when your documents do not have IDs or you want to use Elasticsearch's automatic ID generation.https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html#_automatic_id_generationThe document must implement the Elasticsearch.Document. protocol.ExampleIndex.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) Elasticsearch.post_document(Cluster, %Post{title: &quot;Post&quot;}, &quot;posts-1&quot;) # =&gt; {:ok, # =&gt; %{ # =&gt; &quot;_id&quot; =&gt; &quot;W0tpsmIBdwcYyG50zbta&quot;, # =&gt; &quot;_index&quot; =&gt; &quot;posts-1&quot;, # =&gt; &quot;_primary_term&quot; =&gt; 1, # =&gt; &quot;_seq_no&quot; =&gt; 0, # =&gt; &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, # =&gt; &quot;_type&quot; =&gt; &quot;_doc&quot;, # =&gt; &quot;_version&quot; =&gt; 1, # =&gt; &quot;result&quot; =&gt; &quot;created&quot; # =&gt; }}","ref":"Elasticsearch.html#post_document/3","title":"Elasticsearch.post_document/3","type":"function"},{"doc":"Puts data to a given Elasticsearch API path.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Elasticsearch.put(Cluster, &quot;/posts-1/_doc/id&quot;, %{&quot;title&quot; =&gt; &quot;title&quot;, &quot;author&quot; =&gt; &quot;author&quot;}) {:ok, %{ &quot;_id&quot; =&gt; &quot;id&quot;, &quot;_index&quot; =&gt; &quot;posts-1&quot;, &quot;_primary_term&quot; =&gt; 1, &quot;_seq_no&quot; =&gt; 0, &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, &quot;_type&quot; =&gt; &quot;_doc&quot;, &quot;_version&quot; =&gt; 1, &quot;result&quot; =&gt; &quot;created&quot; }} iex&gt; Elasticsearch.put(Cluster, &quot;/bad/url&quot;, %{&quot;title&quot; =&gt; &quot;title&quot;, &quot;author&quot; =&gt; &quot;author&quot;}) {:error, %Elasticsearch.Exception{col: nil, line: nil, message: &quot;Incorrect HTTP method for uri [/bad/url] and method [PUT], allowed: [POST]&quot;, query: nil, raw: nil, status: nil, type: nil}}","ref":"Elasticsearch.html#put/4","title":"Elasticsearch.put/4","type":"function"},{"doc":"The same as put/2, but returns the response instead of a tuple. Raises on errors.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Elasticsearch.put!(Cluster, &quot;/posts/_doc/id&quot;, %{&quot;name&quot; =&gt; &quot;name&quot;, &quot;author&quot; =&gt; &quot;author&quot;}) %{ &quot;_id&quot; =&gt; &quot;id&quot;, &quot;_index&quot; =&gt; &quot;posts&quot;, &quot;_primary_term&quot; =&gt; 1, &quot;_seq_no&quot; =&gt; 0, &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, &quot;_type&quot; =&gt; &quot;_doc&quot;, &quot;_version&quot; =&gt; 1, &quot;result&quot; =&gt; &quot;created&quot; } iex&gt; Elasticsearch.put!(Cluster, &quot;/bad/url&quot;, %{&quot;data&quot; =&gt; &quot;here&quot;}) ** (Elasticsearch.Exception) Incorrect HTTP method for uri [/bad/url] and method [PUT], allowed: [POST]","ref":"Elasticsearch.html#put!/4","title":"Elasticsearch.put!/4","type":"function"},{"doc":"Creates or updates a document in a given index.The document must implement the Elasticsearch.Document protocol.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; struct = %Post{id: 123, title: &quot;Post&quot;, author: &quot;Author&quot;} ...&gt; Elasticsearch.put_document(Cluster, struct, &quot;posts-1&quot;) {:ok, %{ &quot;_id&quot; =&gt; &quot;123&quot;, &quot;_index&quot; =&gt; &quot;posts-1&quot;, &quot;_primary_term&quot; =&gt; 1, &quot;_seq_no&quot; =&gt; 0, &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, &quot;_type&quot; =&gt; &quot;_doc&quot;, &quot;_version&quot; =&gt; 1, &quot;result&quot; =&gt; &quot;created&quot; }}","ref":"Elasticsearch.html#put_document/3","title":"Elasticsearch.put_document/3","type":"function"},{"doc":"Same as put_document/2, but raises on errors.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; struct = %Post{id: 123, title: &quot;Post&quot;, author: &quot;Author&quot;} ...&gt; Elasticsearch.put_document!(Cluster, struct, &quot;posts-1&quot;) %{ &quot;_id&quot; =&gt; &quot;123&quot;, &quot;_index&quot; =&gt; &quot;posts-1&quot;, &quot;_primary_term&quot; =&gt; 1, &quot;_seq_no&quot; =&gt; 0, &quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 1, &quot;total&quot; =&gt; 2}, &quot;_type&quot; =&gt; &quot;_doc&quot;, &quot;_version&quot; =&gt; 1, &quot;result&quot; =&gt; &quot;created&quot; }","ref":"Elasticsearch.html#put_document!/3","title":"Elasticsearch.put_document!/3","type":"function"},{"doc":"Waits for a given Elasticsearch cluster to be available.It will try a given number of times, with 1sec delay between tries.","ref":"Elasticsearch.html#wait_for_boot/3","title":"Elasticsearch.wait_for_boot/3","type":"function"},{"doc":"","ref":"Elasticsearch.html#t:data/0","title":"Elasticsearch.data/0","type":"type"},{"doc":"","ref":"Elasticsearch.html#t:index_name/0","title":"Elasticsearch.index_name/0","type":"type"},{"doc":"","ref":"Elasticsearch.html#t:opts/0","title":"Elasticsearch.opts/0","type":"type"},{"doc":"","ref":"Elasticsearch.html#t:response/0","title":"Elasticsearch.response/0","type":"type"},{"doc":"","ref":"Elasticsearch.html#t:url/0","title":"Elasticsearch.url/0","type":"type"},{"doc":"Behaviour for interacting with the Elasticsearch JSON API.","ref":"Elasticsearch.API.html","title":"Elasticsearch.API","type":"behaviour"},{"doc":"Makes a request to an Elasticsearch JSON API URl using the given method.","ref":"Elasticsearch.API.html#c:request/5","title":"Elasticsearch.API.request/5","type":"callback"},{"doc":"A payload of data to send, relevant to :put and :post requests","ref":"Elasticsearch.API.html#t:data/0","title":"Elasticsearch.API.data/0","type":"type"},{"doc":"An HTTP method","ref":"Elasticsearch.API.html#t:method/0","title":"Elasticsearch.API.method/0","type":"type"},{"doc":"A keyword list of options to pass to HTTPoison/Hackney","ref":"Elasticsearch.API.html#t:opts/0","title":"Elasticsearch.API.opts/0","type":"type"},{"doc":"","ref":"Elasticsearch.API.html#t:response/0","title":"Elasticsearch.API.response/0","type":"type"},{"doc":"The URL to request from the API","ref":"Elasticsearch.API.html#t:url/0","title":"Elasticsearch.API.url/0","type":"type"},{"doc":"A &quot;real&quot; HTTP implementation of Elasticsearch.API.","ref":"Elasticsearch.API.HTTP.html","title":"Elasticsearch.API.HTTP","type":"module"},{"doc":"Defines and holds configuration for your Elasticsearch cluster.defmodule MyApp.ElasticsearchCluster do use Elasticsearch.Cluster endOnce you have created your cluster, add it to your application's supervision tree:children = [ MyApp.ElasticsearchCluster ]Finally, you can issue requests to Elasticsearch using it.Elasticsearch.get(MyApp.ElasticsearchCluster, &quot;/_cat/health&quot;)ConfigurationClusters can be configured in several ways.Via MixClusters can read configuration from the mix config, if you pass the :otp_app option:defmodule MyApp.ElasticsearchCluster do use Elasticsearch.Cluster, otp_app: :my_app end # In your config/config.exs... config :my_app, MyApp.ElasticsearchCluster, url: &quot;http://localhost:9200&quot;, # ...Via init/1When a cluster starts, you can override its configuration via the init/1 callback. This is a good place to read from environment variables.defmodule MyApp.ElasticsearchCluster do use Elasticsearch.Cluster def init(config) do config = config |&gt; Map.put(:url, System.get_env(&quot;ELASTICSEARCH_URL&quot;)) # ... {:ok, config} end endVia start_link/1You can also pass configuration into the cluster directly when you start it with start_link/1.MyApp.Elasticsearch.start_link(url: &quot;http://localhost:9200&quot;, ...)Configuration OptionsThe following options are available for configuration.:url - The URL at which the Elasticsearch cluster is available.:api - The API module to use to communicate with Elasticsearch. Must implement the Elasticsearch.API behaviour.:bulk_page_size - When creating indexes via bulk upload, how many documents to include per request.:bulk_wait_interval - The number of milliseconds to wait between bulk upload requests.:indexes - A map of indexes. Used by mix elasticsearch.build to build indexes.:settings: The file path of the JSON settings for the index.:store: An Elasticsearch.Store module to use to load data for the index.:sources: A list of sources you want to load for this index.:json_library (Optional) - The JSON library to use. (E.g. Poison or Jason):username (Optional) - The HTTP Basic username for the Elasticsearch endpoint, if any.:password (Optional) - The HTTP Basic password for the Elasticsearch endpoint, if any.:default_headers (Optional) - A list of default headers to send with the each request.:default_options (Optional) - A list of default HTTPoison/Hackney options to send with each request.Configuration Example%{ api: Elasticsearch.API.HTTP, json_library: Poison, url: &quot;http://localhost:9200&quot;, username: &quot;username&quot;, password: &quot;password&quot;, default_headers: [{&quot;authorization&quot;, &quot;custom-value&quot;}], default_options: [ssl: [{:versions, [:&#39;tlsv1.2&#39;]}], indexes: %{ posts: %{ settings: &quot;priv/elasticsearch/posts.json&quot;, store: MyApp.ElasticsearchStore, sources: [MyApp.Post], bulk_page_size: 5000, bulk_wait_interval: 5000 } } }","ref":"Elasticsearch.Cluster.html","title":"Elasticsearch.Cluster","type":"module"},{"doc":"Defines valid configuration for a cluster.","ref":"Elasticsearch.Cluster.html#t:config/0","title":"Elasticsearch.Cluster.config/0","type":"type"},{"doc":"A cluster is either a module defined with Elasticsearch.Cluster, or a map that has all the required configuration keys.","ref":"Elasticsearch.Cluster.html#t:t/0","title":"Elasticsearch.Cluster.t/0","type":"type"},{"doc":"Functions for manipulating Elasticsearch indexes.","ref":"Elasticsearch.Index.html","title":"Elasticsearch.Index","type":"module"},{"doc":"Assigns an alias to a given index, simultaneously removing it from prior indexes, with zero downtime.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.alias(Cluster, &quot;posts-1&quot;, &quot;posts&quot;) :ok","ref":"Elasticsearch.Index.html#alias/3","title":"Elasticsearch.Index.alias/3","type":"function"},{"doc":"Generates a name for an index that will be aliased to a given alias. Similar to migrations, the name will contain a timestamp.ExampleIndex.build_name(&quot;main&quot;) # =&gt; &quot;main-1509581256&quot;","ref":"Elasticsearch.Index.html#build_name/1","title":"Elasticsearch.Index.build_name/1","type":"function"},{"doc":"Removes indexes starting with the given prefix, keeping a certain number.Can be used to garbage collect old indexes that are no longer used.ExamplesIf there is only one index, and num_to_keep is &gt;= 1, the index is not deleted.iex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.clean_starting_with(Cluster, &quot;posts&quot;, 1) ...&gt; Index.starting_with(Cluster, &quot;posts&quot;) {:ok, [&quot;posts-1&quot;]}If num_to_keep is less than the number of indexes, the older indexes are deleted.iex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.clean_starting_with(Cluster, &quot;posts&quot;, 0) ...&gt; Index.starting_with(Cluster, &quot;posts&quot;) {:ok, []}","ref":"Elasticsearch.Index.html#clean_starting_with/3","title":"Elasticsearch.Index.clean_starting_with/3","type":"function"},{"doc":"Creates an index with the given name from either a JSON string or Elixir map.Examplesiex&gt; Index.create(Cluster, &quot;posts-1&quot;, &quot;{}&quot;) :ok","ref":"Elasticsearch.Index.html#create/3","title":"Elasticsearch.Index.create/3","type":"function"},{"doc":"Creates an index with the given name, with settings loaded from a JSON file.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) :ok iex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;nonexistent.json&quot;) {:error, :enoent}The posts.json file contains regular index settings as described in the Elasticsearch documentation:{ &quot;mappings&quot;: { &quot;post&quot;: { &quot;properties&quot;: { &quot;title&quot;: { &quot;type&quot;: &quot;string&quot; }, &quot;author&quot;: { &quot;type&quot;: &quot;string&quot; } } } } }","ref":"Elasticsearch.Index.html#create_from_file/3","title":"Elasticsearch.Index.create_from_file/3","type":"function"},{"doc":"Creates an index with the given name, with settings loaded from a map or a JSON file (see create_from_file/3).Exampleiex&gt; Index.create_from_settings(Cluster, &quot;posts-1&quot;, %{}) :ok iex&gt; Index.create_from_settings(Cluster, &quot;posts-1&quot;, &quot;nonexistent.json&quot;) {:error, :enoent}","ref":"Elasticsearch.Index.html#create_from_settings/3","title":"Elasticsearch.Index.create_from_settings/3","type":"function"},{"doc":"Creates an index using a zero-downtime hot-swap technique.Build an index for the given alias, with a timestamp: alias-12323123Bulk upload data to that index using store and sources.Alias the alias to alias-12323123.Remove old indexes beginning with alias.Refresh alias-12323123.This allows an old index to be served while a new index for alias is built.Exampleiex&gt; Index.hot_swap(Cluster, &quot;posts&quot;) :ok","ref":"Elasticsearch.Index.html#hot_swap/2","title":"Elasticsearch.Index.hot_swap/2","type":"function"},{"doc":"Gets the most recent index name with the given prefix.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.create_from_file(Cluster, &quot;posts-2&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.latest_starting_with(Cluster, &quot;posts&quot;) {:ok, &quot;posts-2&quot;}If there are no indexes matching that prefix:iex&gt; Index.latest_starting_with(Cluster, &quot;nonexistent&quot;) {:error, :not_found}","ref":"Elasticsearch.Index.html#latest_starting_with/2","title":"Elasticsearch.Index.latest_starting_with/2","type":"function"},{"doc":"Refreshes a given index with recently added data.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.refresh(Cluster, &quot;posts-1&quot;) :ok","ref":"Elasticsearch.Index.html#refresh/2","title":"Elasticsearch.Index.refresh/2","type":"function"},{"doc":"Same as refresh/1, but raises an error on failure.Examplesiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.refresh!(Cluster, &quot;posts-1&quot;) :ok iex&gt; Index.refresh!(Cluster, &quot;nonexistent&quot;) ** (Elasticsearch.Exception) (index_not_found_exception) no such index","ref":"Elasticsearch.Index.html#refresh!/2","title":"Elasticsearch.Index.refresh!/2","type":"function"},{"doc":"Returns all indexes which start with a given string.Exampleiex&gt; Index.create_from_file(Cluster, &quot;posts-1&quot;, &quot;test/support/settings/posts.json&quot;) ...&gt; Index.starting_with(Cluster, &quot;posts&quot;) {:ok, [&quot;posts-1&quot;]}","ref":"Elasticsearch.Index.html#starting_with/2","title":"Elasticsearch.Index.starting_with/2","type":"function"},{"doc":"Functions for creating bulk indexing requests.","ref":"Elasticsearch.Index.Bulk.html","title":"Elasticsearch.Index.Bulk","type":"module"},{"doc":"Encodes a given variable into an Elasticsearch bulk request. The variable must implement Elasticsearch.Document.Examplesiex&gt; Bulk.encode(Cluster, %Post{id: &quot;my-id&quot;}, &quot;my-index&quot;) {:ok, &quot;&quot;&quot; {&quot;create&quot;:{&quot;_index&quot;:&quot;my-index&quot;,&quot;_id&quot;:&quot;my-id&quot;}} {&quot;title&quot;:null,&quot;doctype&quot;:{&quot;name&quot;:&quot;post&quot;},&quot;author&quot;:null} &quot;&quot;&quot;} iex&gt; Bulk.encode(Cluster, 123, &quot;my-index&quot;) {:error, %Protocol.UndefinedError{description: &quot;&quot;, protocol: Elasticsearch.Document, value: 123}}","ref":"Elasticsearch.Index.Bulk.html#encode/4","title":"Elasticsearch.Index.Bulk.encode/4","type":"function"},{"doc":"Same as encode/3, but returns the request and raises errors.Exampleiex&gt; Bulk.encode!(Cluster, %Post{id: &quot;my-id&quot;}, &quot;my-index&quot;) &quot;&quot;&quot; {&quot;create&quot;:{&quot;_index&quot;:&quot;my-index&quot;,&quot;_id&quot;:&quot;my-id&quot;}} {&quot;title&quot;:null,&quot;doctype&quot;:{&quot;name&quot;:&quot;post&quot;},&quot;author&quot;:null} &quot;&quot;&quot; iex&gt; Bulk.encode!(Cluster, 123, &quot;my-index&quot;) ** (Protocol.UndefinedError) protocol Elasticsearch.Document not implemented for 123 of type Integer","ref":"Elasticsearch.Index.Bulk.html#encode!/4","title":"Elasticsearch.Index.Bulk.encode!/4","type":"function"},{"doc":"Uploads all the data from the list of sources to the given index. Data for each source will be fetched using the configured :store.","ref":"Elasticsearch.Index.Bulk.html#upload/4","title":"Elasticsearch.Index.Bulk.upload/4","type":"function"},{"doc":"A protocol for converting a struct into an Elasticsearch document.Exampledefimpl Elasticsearch.Document, for: MyStruct do def id(struct), do: struct.id def encode(struct) do %{ id: struct.id, name: struct.name } end end","ref":"Elasticsearch.Document.html","title":"Elasticsearch.Document","type":"protocol"},{"doc":"Returns a map of fields, which will be converted to JSON and stored in Elasticsearch as a document.Exampledef encode(item) do %{ title: item.title, author: item.author } end","ref":"Elasticsearch.Document.html#encode/1","title":"Elasticsearch.Document.encode/1","type":"function"},{"doc":"Returns the Elasticsearch _id for the item.Exampledef id(item), do: item.id","ref":"Elasticsearch.Document.html#id/1","title":"Elasticsearch.Document.id/1","type":"function"},{"doc":"Returns the Elasticsearch _routing for the item. Elasticsearch default if this value is not provided is to use the _id. Setting this value to false or nil will omit sending the meta-field with your requests and use default routing behaviour. Routing allows you to control which shard the document should be directed to which is necessary for join fields.ExampleSpecify a routing key to control the destination shard, like so:def routing(item), do: item.parent_idor omit routing and use default Elasticsearch functionality:def routing(_), do: false","ref":"Elasticsearch.Document.html#routing/1","title":"Elasticsearch.Document.routing/1","type":"function"},{"doc":"","ref":"Elasticsearch.Document.html#t:t/0","title":"Elasticsearch.Document.t/0","type":"type"},{"doc":"A behaviour for fetching data to index using a streaming strategy.","ref":"Elasticsearch.Store.html","title":"Elasticsearch.Store","type":"behaviour"},{"doc":"Returns a stream of the given datasource.Exampledef stream(Post) do Repo.stream(Post) end","ref":"Elasticsearch.Store.html#c:stream/1","title":"Elasticsearch.Store.stream/1","type":"callback"},{"doc":"Returns a transaction wrapper to execute the stream returned by stream/1 within. This is required when using Ecto.Exampledef transaction(fun) do {:ok, result} = Repo.transaction(fun, timeout: :infinity) result endIf you are not using Ecto and do not require transactions, simply call the function passed as a parameter.def transaction(fun) do fun.() end","ref":"Elasticsearch.Store.html#c:transaction/1","title":"Elasticsearch.Store.transaction/1","type":"callback"},{"doc":"Wraps an Elasticsearch executable so it can be run as part of the Elixir supervision tree.See Mix.Tasks.Elasticsearch.Install to install Elasticsearch to a directory for your project.ExampleAdd a worker to your supervision tree, like so:worker(Elasticsearch.Executable, [ &quot;Elasticsearch&quot;, &quot;./vendor/elasticsearch/bin/elasticsearch&quot;, 9200 ], id: :elasticsearch),","ref":"Elasticsearch.Executable.html","title":"Elasticsearch.Executable","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Elasticsearch.Executable.html#child_spec/1","title":"Elasticsearch.Executable.child_spec/1","type":"function"},{"doc":"Represents an Elasticsearch exception raised while executing a query.","ref":"Elasticsearch.Exception.html","title":"Elasticsearch.Exception","type":"exception"},{"doc":"","ref":"Elasticsearch.Exception.html#t:t/0","title":"Elasticsearch.Exception.t/0","type":"type"},{"doc":"Elasticsearch A simple, no-nonsense Elasticsearch library for Elixir. Highlights include:No DSLs. Interact directly with the Elasticsearch JSON API.Zero-downtime index (re)building. Via Mix.Tasks.Elasticsearch.Build task.Dev Tools. Helpers for running Elasticsearch as part of your supervision tree during development.","ref":"readme.html","title":"Elasticsearch","type":"extras"},{"doc":"Add elasticsearch to your list of dependencies in mix.exs:def deps do [ {:elasticsearch, &quot;~&gt; 1.0.0&quot;} ] endThen, create an Elasticsearch.Cluster in your application:defmodule MyApp.ElasticsearchCluster do use Elasticsearch.Cluster, otp_app: :my_app endOnce you have created your cluster, add it to your application's supervision tree:children = [ MyApp.ElasticsearchCluster ]Finally, you can issue requests to Elasticsearch using it.Elasticsearch.get(MyApp.ElasticsearchCluster, &quot;/_cat/health&quot;)","ref":"readme.html#installation","title":"Elasticsearch - Installation","type":"extras"},{"doc":"See the annotated example configuration below.config :my_app, MyApp.ElasticsearchCluster, # The URL where Elasticsearch is hosted on your system url: &quot;http://localhost:9200&quot;, # If your Elasticsearch cluster uses HTTP basic authentication, # specify the username and password here: username: &quot;username&quot;, password: &quot;password&quot;, # If you want to mock the responses of the Elasticsearch JSON API # for testing or other purposes, you can inject a different module # here. It must implement the Elasticsearch.API behaviour. api: Elasticsearch.API.HTTP, # Customize the library used for JSON encoding/decoding. json_library: Poison, # or Jason # You should configure each index which you maintain in Elasticsearch here. # This configuration will be read by the `mix elasticsearch.build` task, # described below. indexes: %{ # This is the base name of the Elasticsearch index. Each index will be # built with a timestamp included in the name, like &quot;posts-5902341238&quot;. # It will then be aliased to &quot;posts&quot; for easy querying. posts: %{ # This file describes the mappings and settings for your index. It will # be posted as-is to Elasticsearch when you create your index, and # therefore allows all the settings you could post directly. settings: &quot;priv/elasticsearch/posts.json&quot;, # This store module must implement a store behaviour. It will be used to # fetch data for each source in each indexes&#39; `sources` list, below: store: MyApp.ElasticsearchStore, # This is the list of data sources that should be used to populate this # index. The `:store` module above will be passed each one of these # sources for fetching. # # Each piece of data that is returned by the store must implement the # Elasticsearch.Document protocol. sources: [MyApp.Post], # When indexing data using the `mix elasticsearch.build` task, # control the data ingestion rate by raising or lowering the number # of items to send in each bulk request. bulk_page_size: 5000, # Likewise, wait a given period between posting pages to give # Elasticsearch time to catch up. bulk_wait_interval: 15_000, # 15 seconds # By default bulk indexing uses the &quot;create&quot; action. To allow existing # documents to be replaced, use the &quot;index&quot; action instead. bulk_action: &quot;create&quot; } }Specifying HTTPoison Optionsconfig :my_app, MyApp.ElasticsearchCluster, default_options: [ timeout: 5_000, recv_timeout: 5_000, hackney: [pool: :pool_name] ]","ref":"readme.html#configuration","title":"Elasticsearch - Configuration","type":"extras"},{"doc":"Elasticsearch.StoreYour app must provide a Store module, which will fetch data to upload to Elasticsearch. This module must implement the Elasticsearch.Store behaviour.The example below uses Ecto, but you can implement the behaviour on top of any persistence layer.defmodule MyApp.ElasticsearchStore do @behaviour Elasticsearch.Store import Ecto.Query alias MyApp.Repo @impl true def stream(schema) do Repo.stream(schema) end @impl true def transaction(fun) do {:ok, result} = Repo.transaction(fun, timeout: :infinity) result end endElasticsearch.DocumentEach result returned by your store must implement the Elasticsearch.Document protocol.defimpl Elasticsearch.Document, for: MyApp.Post do def id(post), do: post.id def routing(_), do: false def encode(post) do %{ title: post.title, author: post.author } end endElasticsearch.APIYou can plug in a different module to make API requests, as long as it implements the Elasticsearch.API behaviour.This can be used in test mode, for example:# config/test.exs config :my_app, MyApp.ElasticsearchCluster, api: MyApp.ElasticsearchMockYour mock can then stub requests and responses from Elasticsearch.defmodule MyApp.ElasticsearchMock do @behaviour Elasticsearch.API @impl true def request(_config, :get, &quot;/posts/1&quot;, _data, _opts) do {:ok, %HTTPoison.Response{ status_code: 404, body: %{ &quot;status&quot; =&gt; &quot;not_found&quot; } }} end endElasticsearch.API.AWSAs AWS does not provide credentials' based http authentication, you can use the Elasticsearch.API.AWS module if you want to use AWS Elasticsearch Service with AWS Signature V4 signed HTTP connections.To use this, just add sigaws to your dependencies and add this to your configuration:# Add to deps def deps do [ # ... {:sigaws, &quot;&gt;= 0.0.0&quot;} ] end # config/prod.exs config :my_app, MyApp.ElasticsearchCluster, api: Elasticsearch.API.AWS, default_options: [ aws: [ region: &quot;us-east-1&quot;, service: &quot;es&quot;, access_key: &quot;aws_access_key_id&quot;, secret: &quot;aws_secret_access_key&quot; ] ]","ref":"readme.html#protocols-and-behaviours","title":"Elasticsearch - Protocols and Behaviours","type":"extras"},{"doc":"BulkUse the mix elasticsearch.build task to build indexes using a zero-downtime, hot-swap technique with Elasticsearch aliases.# This will read the `indexes[posts]` configuration seen above, to build # an index, `posts-123123123`, which will then be aliased to `posts`. $ mix elasticsearch.build posts --cluster MyApp.ElasticsearchClusterSee the docs on Mix.Tasks.Elasticsearch.Build and Elasticsearch.Index for more details.Individual DocumentsUse Elasticsearch.put_document/3 to upload a document to a particular index.# MyApp.Post must implement Elasticsearch.Document Elasticsearch.put_document(MyApp.ElasticsearchCluster, %MyApp.Post{}, &quot;index-name&quot;)To remove documents, use Elasticsearch.delete_document/3:Elasticsearch.delete_document(MyApp.ElasticsearchCluster, %MyApp.Post{}, &quot;index-name&quot;)","ref":"readme.html#indexing","title":"Elasticsearch - Indexing","type":"extras"},{"doc":"You can query Elasticsearch the post/3 function:# Raw query Elasticsearch.post(MyApp.ElasticsearchCluster, &quot;/posts/_doc/_search&quot;, &#39;{&quot;query&quot;: {&quot;match_all&quot;: {}}}&#39;) # Using a map Elasticsearch.post(MyApp.ElasticsearchCluster, &quot;/posts/_doc/_search&quot;, %{&quot;query&quot; =&gt; %{&quot;match_all&quot; =&gt; %{}}})See the official Elasticsearch documentation for how to write queries.","ref":"readme.html#querying","title":"Elasticsearch - Querying","type":"extras"},{"doc":"This package provides two utilities for developing with Elasticsearch:mix elasticsearch.install: A mix task to install Elasticsearch and Kibana to a folder of your choosing.Elasticsearch.Executable. Use this to start and stop Elasticsearch as part of your supervision tree.children = [ worker(Elasticsearch.Executable, [ &quot;Elasticsearch&quot;, &quot;./vendor/elasticsearch/bin/elasticsearch&quot;, # assuming elasticsearch is in your vendor/ dir 9200 ], id: :elasticsearch), worker(Elasticsearch.Executable, [ &quot;Kibana&quot;, &quot;./vendor/kibana/bin/kibana&quot;, # assuming kibana is in your vendor/ dir 5601 ], id: :kibana) ]","ref":"readme.html#dev-tools","title":"Elasticsearch - Dev Tools","type":"extras"},{"doc":"As of version 0.3.0 of this client library, multiple document types are not supported, because support for these was removed in Elasticsearch 6.x. You can still use this library with Elasticsearch 5.x, but you must design your indexes in the Elasticsearch 6.x style.Read more about this in Elasticsearch's guide, &quot;Removal of Mapping Types&quot;.","ref":"readme.html#elasticsearch-5-x-support","title":"Elasticsearch - Elasticsearch 5.x Support","type":"extras"},{"doc":"Hex DocumentationRun mix docs to generate local documentation.","ref":"readme.html#documentation","title":"Elasticsearch - Documentation","type":"extras"},{"doc":"To contribute code to this project, you'll need to:Fork the repoClone your forkRun bin/setupCreate a branchCommit your changesOpen a PR","ref":"readme.html#contributing","title":"Elasticsearch - Contributing","type":"extras"},{"doc":"Deploying with DistilleryBecause Distillery 1-2.x does not support Mix Tasks, you must do some extra work to use this library's hot swap feature. As shown in Distillery's official documentation, you will need to create a ReleaseTasks module.defmodule MyApp.ReleaseTasks do # OTP apps that must be started in order for the code in this module # to function properly. # # Don&#39;t forget about Ecto and Postgrex if you&#39;re using Ecto to load documents # in your Elasticsearch.Store module! @start_apps [ :crypto, :ssl, :postgrex, :ecto, :elasticsearch ] # Ecto repos to start, if any @repos Application.get_env(:my_app, :ecto_repos, []) # Elasticsearch clusters to start @clusters [MyApp.Cluster] # Elasticsearch indexes to build @indexes [:posts] def build_elasticsearch_indexes(_argv) do start_services() IO.puts(&quot;Building indexes...&quot;) Enum.each(@indexes, &amp;Elasticsearch.Index.hot_swap(MyApp.Cluster, &amp;1)) stop_services() end # Ensure that all OTP apps, repos used by your Elasticsearch store, # and your Elasticsearch Cluster(s) are started defp start_services do IO.puts(&quot;Starting dependencies...&quot;) Enum.each(@start_apps, &amp;Application.ensure_all_started/1) IO.puts(&quot;Starting repos...&quot;) Enum.each(@repos, &amp; &amp;1.start_link(pool_size: 1)) IO.puts(&quot;Starting clusters...&quot;) Enum.each(@clusters, &amp; &amp;1.start_link()) end defp stop_services do :init.stop() end endThen, create a custom command in rel/commands:# rel/commands/build_elasticsearch_indexes.sh #!/bin/sh release_ctl eval --mfa &quot;MyApp.ReleaseTasks.build_elasticsearch_indexes/1&quot; -- &quot;$@&quot;Finally, set up your rel/config.exs file:release :myapp do ... set commands: [ build_elasticsearch_indexes: &quot;rel/commands/build_elasticsearch_indexes.sh&quot;, ] endNow, once you've deployed the application, you can build indexes with bin/myapp build_elasticsearch_indexes.","ref":"distillery.html","title":"Distillery","type":"extras"},{"doc":"Upgrading from 0.4.x to 0.5.x","ref":"0-4-x_to_0-5-x.html","title":"0.4.x to 0.5.x","type":"extras"},{"doc":"BREAKING: routing function is now required to be specified in the Elasticsearch.Document protocol. You may specify it to return false to use default routing (document id).The routing/_routing meta-field is used to force a document to be hashed to a particular shard which is required for join field datatypes but also used to gain more control over which shard your documents are routed to.BREAKING: The Elasticsearch.Store behaviour has been changed to use streams instead of limit/offset. This is more performant on SQL databases.BREAKING: Index.hot_swap/3 was refactored to take only 2 arguments, the cluster and the index to be built. This makes it easier to call.Feature: This library now better supports Distillery for deployment. See the Distillery guide for details.","ref":"0-4-x_to_0-5-x.html#changes","title":"0.4.x to 0.5.x - Changes","type":"extras"},{"doc":"Update your Hex dependency from 0.4.x to 0.5.x: {:elasticsearch, &quot;~&gt; 0.5.0&quot;}Add a routing/1 function to your Elasticsearch.Document implementations.# BEFORE defimpl Elasticsearch.Document, for: MyApp.Post do def id(post), do: post.id def encode(post) do %{ title: post.title, author: post.author } end end # AFTER (using default routing) defimpl Elasticsearch.Document, for: MyApp.Post do def id(post), do: post.id def routing(_), do: false def encode(post) do %{ title: post.title, author: post.author } end end # AFTER (using routing) defimpl Elasticsearch.Document, for: MyApp.Post do def id(post), do: post.id def routing(post), do: post.account_id def encode(post) do %{ title: post.title, author: post.author } end endChange your Elasticsearch.Store module to use streams. Here's an example if you're using Ecto.# BEFORE def MyApp.ElasticsearchStore do @behaviour Elasticsearch.Store import Ecto.Query alias MyApp.Repo @impl true def load(schema, offset, limit) do schema |&gt; offset(^offset) |&gt; limit(^limit) |&gt; Repo.all() end end # AFTER defmodule MyApp.ElasticsearchStore do @behaviour Elasticsearch.Store alias MyApp.Repo @impl true def transaction(fun) do {:ok, result} = Repo.transaction(fun) result end @impl true def stream(schema) do Repo.stream(schema) end end","ref":"0-4-x_to_0-5-x.html#how-to-update-your-app","title":"0.4.x to 0.5.x - How to Update Your App","type":"extras"},{"doc":"Upgrading from 0.3.x to 0.4.xVersion 0.4.0 moved the :bulk_page_size and :bulk_wait_interval settings into each index's configuration, rather than global on the cluster.","ref":"0-3-x_to_0-4-x.html","title":"0.3.x to 0.4.x","type":"extras"},{"doc":"This makes it easier to have different bulk settings for different indexes.","ref":"0-3-x_to_0-4-x.html#rationale","title":"0.3.x to 0.4.x - Rationale","type":"extras"},{"doc":"BREAKING: :bulk_page_size and :bulk_wait_interval are now configured on the index, not the cluster.Elasticsearch.Index.hot_swap/5 is now Elasticsearch.Index.hot_swap/3 where options are passed as a map.FEATURE: You can now pass --bulk-wait-interval and --bulk-page-size options to mix elasticsearch.build, as requested in #26.","ref":"0-3-x_to_0-4-x.html#changes","title":"0.3.x to 0.4.x - Changes","type":"extras"},{"doc":"Move the :bulk_page_size and :bulk_wait_interval settings to your index rather than your entire cluster.# BEFORE config :my_app, MyApp.ElasticsearchCluster, api: Elasticsearch.API.HTTP, json_library: Poison, url: &quot;http://localhost:9200&quot;, username: &quot;username&quot;, password: &quot;password&quot;, bulk_page_size: 5000, bulk_wait_interval: 0, indexes: %{ posts: %{ settings: &quot;test/support/settings/posts.json&quot;, store: Elasticsearch.Test.Store, sources: [Post] } } # AFTER config :my_app, MyApp.ElasticsearchCluster, api: Elasticsearch.API.HTTP, json_library: Poison, url: &quot;http://localhost:9200&quot;, username: &quot;username&quot;, password: &quot;password&quot;, indexes: %{ posts: %{ settings: &quot;test/support/settings/posts.json&quot;, store: Elasticsearch.Test.Store, sources: [Post], bulk_page_size: 5000, bulk_wait_interval: 0 } }Change the Elasticsearch.Index.hot_swap/5 call to Elasticsearch.Index.hot_swap/3# BEFORE Elasticsearch.Index.hot_swap(MyApp.Cluster, &quot;index-name&quot;, &quot;path/to/settings&quot;, MyApp.Store, [MyApp.Source]) # AFTER Elasticsearch.Index.hot_swap(MyApp.Cluster, &quot;index-name&quot;, %{settings: &quot;path/to/settings&quot;, store: MyApp.Store, sources: [MyApp.Source]})","ref":"0-3-x_to_0-4-x.html#how-to-update-your-app","title":"0.3.x to 0.4.x - How to Update Your App","type":"extras"},{"doc":"Upgrading from 0.2.x to 0.3.xVersion 0.3.0 dropped support for some Elasticsearch 5.x features that have been deprecated or removed in Elasticsearch 6.x.","ref":"0-2-x_to_0-3-x.html","title":"0.2.x to 0.3.x","type":"extras"},{"doc":"As noted in the Elasticsearch document &quot;Removal of mapping types&quot;, Elasticsearch no longer supports multiple document types per index.Instead, each index is expected to have a single type, _doc, and handle parent/child relationships with the new join field.To support this, version 0.3.0 of this client library makes some breaking changes. You should still be able to use 0.3.0 with Elasticsearch 5.x, but you will need to convert your indexes over to the 6.x style if they aren't designed that way already.","ref":"0-2-x_to_0-3-x.html#rationale","title":"0.2.x to 0.3.x - Rationale","type":"extras"},{"doc":"BREAKING: Removed type and parent functions from Elasticsearch.Document protocol. BREAKING: Required cluster as an argument to Index.Bulk.encode functions.BREAKING: mix elasticsearch.build, Index.hot_swap/5 and Bulk.upload/5 will post documents to /index_name/_doc/_bulk, therefore assuming that your index's only type is named _doc. (As shown in all Elasticsearch sample documentation)IMPROVED: Bulk.upload/5 now respects your cluster's :bulk_wait_interval setting. This allows you to space your requests to prevent overloading your Elasticsearch cluster.IMPROVED: Test coverage was increased to 93%.FIXED: Bulk.upload/5 now properly handles errors on repeated runs. See danielberkompas/elasticsearch-elixir#10","ref":"0-2-x_to_0-3-x.html#changes","title":"0.2.x to 0.3.x - Changes","type":"extras"},{"doc":"First, remove type and parent definitions from all your implementations of Elasticsearch.Document:# BEFORE defimpl Elasticsearch.Document, for: MyApp.Struct do def type(struct), do: &quot;struct&quot; def parent(_struct), do: false def id(struct), do: struct.id def encode(struct) do %{ # ... } end end # AFTER defimpl Elasticsearch.Document, for: MyApp.Struct do def id(struct), do: struct.id def encode(struct) do %{ # ... } end endNext, if you call Bulk.encode functions manually, be sure to pass your cluster into them.# BEFORE Bulk.encode(%MyApp.Struct{}, &quot;index_name&quot;) # AFTER Bulk.encode(MyApp.ElasticsearchCluster, %MyApp.Struct{}, &quot;index_name&quot;)Next, update your index structure to no longer have multiple types per index in your index settings .json files. Also, rename your type to _doc.# BEFORE { &quot;mappings&quot;: { &quot;post&quot;: { &quot;properties&quot;: { &quot;title&quot;: { &quot;type&quot;: &quot;text&quot; }, &quot;author&quot;: { &quot;type&quot;: &quot;text&quot; } } } } } # AFTER { &quot;mappings&quot;: { &quot;_doc&quot;: { &quot;properties&quot;: { &quot;title&quot;: { &quot;type&quot;: &quot;text&quot; }, &quot;author&quot;: { &quot;type&quot;: &quot;text&quot; } } } } }","ref":"0-2-x_to_0-3-x.html#how-to-update-your-app","title":"0.2.x to 0.3.x - How to Update Your App","type":"extras"},{"doc":"Upgrading from 0.1.x to 0.2.xVersion 0.2.0 brings this library in line with Elixir best practices for configuration.","ref":"0-1-x_to_0-2-x.html","title":"0.1.x to 0.2.x","type":"extras"},{"doc":"Configuration is no longer global. Instead, you configure Elasticsearch.Cluster modules, which are GenServers. This has several benefits:A single OTP app can talk to multiple Elasticsearch clusters. This is useful for umbrella apps in particular.Reading from environment variables is standardized. You do it by overriding the cluster's init/1 callback, as in Ecto and Phoenix.You can start clusters like any other genserver, passing in configuration at that time.You can bypass clusters altogether by passing configuration instead of a cluster to any function that expects a cluster.","ref":"0-1-x_to_0-2-x.html#rationale","title":"0.1.x to 0.2.x - Rationale","type":"extras"},{"doc":"BREAKING: an Elasticsearch.Cluster module or configuration map is now required for all Elasticsearch function calls.BREAKING: {:system, &quot;ENV_VAR&quot;} is no longer supported in configuration. Instead, you should read from environment variables in the init/1 callback as described in the Elasticsearch.Cluster documentation.BREAKING: The :api_module configuration option has been renamed to :api.BREAKING: The required callbacks for Elasticsearch.API have been simplified down to a single request/5 function.BREAKING: mix elasticsearch.build now requires the --cluster option.","ref":"0-1-x_to_0-2-x.html#changes","title":"0.1.x to 0.2.x - Changes","type":"extras"},{"doc":"First, add a Cluster to your application:defmodule MyApp.ElasticsearchCluster do use Elasticsearch.Cluster, otp_app: :my_app endNext, switch over your :elasticsearch configuration over to your application, and include the cluster. Be sure to rename the :api_module option to :api. See Elasticsearch.Cluster for more options.# BEFORE config :elasticsearch, url: &quot;http://localhost:9200&quot;, api_module: Elasticsearch.API.HTTP, # ... # AFTER config, :my_app, MyApp.ElasticsearchCluster, url: &quot;http://localhost:9200&quot;, api: Elasticsearch.API.HTTP, # ...Next, be sure to start your Cluster in your application supervisor:children = [ MyApp.ElasticsearchCluster ]Next, add your cluster to all calls to Elasticsearch functions:# BEFORE Elasticsearch.post(&quot;/posts/_search&quot;, %{...}) # AFTER Elasticsearch.post(MyApp.ElasticsearchCluster, &quot;/posts/_search&quot;, %{...})Next, update any mock implementations of Elasticsearch.API to implement the request/5 function instead of the previous functions.# BEFORE defmodule MyApp.ElasticsearchMock do @behaviour Elasticsearch.API def get(&quot;/url&quot;, _opts) do {:ok, %HTTPoison.Response{}} end end # AFTER defmodule MyApp.ElasticsearchMock do @behaviour Elasticsearch.API @impl true def request(_config, :get, &quot;/url&quot;, _data, _opts) do {:ok, %HTTPoison.Response{}} end endFinally, update any calls to mix elasticsearch.build to include the cluster as an option:mix elasticsearch.build [index] --cluster MyApp.ElasticsearchCluster","ref":"0-1-x_to_0-2-x.html#how-to-update-your-app","title":"0.1.x to 0.2.x - How to Update Your App","type":"extras"}]